#include <iostream>
#include <cmath>
#include <iomanip>

using namespace std;

char Map[250][250];
float Path[250][250];

struct POINT
{
    long X;
    long Y;
};

long MIN(float A, float B, float C, float D)
{
    return (A < B ? A : B) < (C < D ? C : D) ? (A < B ? A : B) : (C < D ? C : D);
}

POINT Pesho()
{
    for (long j = 0; j < 250; j++)
    {
        for (long i = 0; i < 250; i++)
        {
            if (Map[i][j] == 'S')
            {
                return {i, j};
            }
        }
    }
}

POINT Destination()
{
    for (long j = 0; j < 250; j++)
    {
        for (long i = 0; i < 250; i++)
        {
            if (Map[i][j] == 'D')
            {
                return {i, j};
            }
        }
    }
}

POINT Water()
{
    for (long j = 0; j < 250; j++)
    {
        for (long i = 0; i < 250; i++)
        {
            if (Map[i][j] == '*')
            {
                return {i, j};
            }
        }
    }
}

void Init(POINT P, POINT D, POINT W)
{
    for (long j = 0; j < 250; j++)
    {
        for (long i = 0; i < 250; i++)
        {
            Path[i][j] = sqrt(abs(P.X - i) * abs(P.X - i) + abs(P.Y - j) * abs(P.Y - j));
            Path[i][j] += sqrt(abs(D.X - i) * abs(D.X - i) + abs(D.Y - j) * abs(D.Y - j));
            Path[i][j] -= sqrt(abs(W.X - i) * abs(W.X - i) + abs(W.Y - j) * abs(W.Y - j));
            if (Map[i][j] == 'X')
            {
                Path[i][j] = 100000;
            }
        }
    }
}

int main()
{
    long R;
    long C;
    long P = 0;
    POINT PE;
    POINT D;

    cin >> R;
    cin >> C;

    for (long j = 0; j < R; j++)
    {
        for (long i = 0; i < C; i++)
        {
            cin >> Map[i][j];
        }
    }

    cout << setprecision(4);

    Init(Pesho(), Destination(), Water());

    PE = Pesho();
    D = Destination();

    while (PE.X != D.X or PE.Y != D.Y)
    {
        if (MIN(Path[PE.X][PE.Y + 1], Path[PE.X][PE.Y - 1], Path[PE.X + 1][PE.Y], Path[PE.X - 1][PE.Y] == Path[PE.X][PE.Y + 1]))
        {
            PE.Y++;
        }
        else if (MIN(Path[PE.X][PE.Y + 1], Path[PE.X][PE.Y - 1], Path[PE.X + 1][PE.Y], Path[PE.X - 1][PE.Y] == Path[PE.X][PE.Y - 1]))
        {
            PE.Y--;
        }
        else if (MIN(Path[PE.X][PE.Y + 1], Path[PE.X][PE.Y - 1], Path[PE.X + 1][PE.Y], Path[PE.X - 1][PE.Y] == Path[PE.X + 1][PE.Y]))
        {
            PE.X++;
        }
        else if (MIN(Path[PE.X][PE.Y + 1], Path[PE.X][PE.Y - 1], Path[PE.X + 1][PE.Y], Path[PE.X - 1][PE.Y] == Path[PE.X - 1][PE.Y]))
        {
            PE.X--;
        }
        P++;
    }

    cout << P;
}
